#ifndef _MASTER_H
#define _MASTER_H

#include "slist.h"
#include "network.h"

typedef struct
{
	char *name;
	int sec;
	int usec;
}
BenchmarkResult;

typedef struct
{
	int tid;
	char *name;
	int master;
	int child_tid;

	unsigned long int memsize;

	SList *cpus;
	SList *bm_results;
	SList *pcidevs;		/* PciDevInfo */

	NetworkInterfaceInfo *eth0;
}
ClientInfo;

int master_spawn(const char *cmd, SList **client_list);
int master_collect(int nhost, SList *clients);

#endif /* _MASTER_H */
