#include <stdlib.h>
#include <stdio.h>
#include <limits.h>

#include <sys/time.h>

#define MBM_INT_MIN -16777216
#define MBM_INT_MAX 268435456

static struct timeval *timer_start()
{
	struct timeval *tv;
	tv = malloc(sizeof(struct timeval));

	gettimeofday(tv, NULL);

	return tv;
}

static struct timeval *timer_stop(struct timeval *timeatstart)
{
	struct timeval timeatend, *timediff;

	gettimeofday(&timeatend, NULL);

	timediff = malloc(sizeof(struct timeval));

	timediff->tv_sec = timeatend.tv_sec - timeatstart->tv_sec;

	if((timeatend.tv_usec - timeatstart->tv_usec) < 0)
	{
		timediff->tv_usec = 1000000 +
			(timeatend.tv_usec - timeatstart->tv_usec);
		timediff->tv_sec --;
	}
	else
	{
		timediff->tv_usec = timeatend.tv_usec - timeatstart->tv_usec;
	}

	return timediff;
}

struct timeval *mbm_bench_int()
{
	int i, x = 1;
	int op = INT_MAX;
	struct timeval *timeatstart, *rettv;

	timeatstart = timer_start();

	for(i=MBM_INT_MIN; i<=MBM_INT_MAX; i++)
	{
		x -= op--;
		x *= op--;
		x += op--;
		if(op == 0)
		{
			op = INT_MAX;
		}
		x /= op--;
	}

	rettv =  timer_stop(timeatstart);

	free(timeatstart);

	return rettv;
}


