#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <assert.h>
#include <unistd.h>

#include <pvm3.h>
#include <pci/pci.h>

#include "main.h"

#define DEBUG 0

int pciinfo(void)
{
	struct pci_access *pacc;
	struct pci_dev *dev;
	unsigned int c;

	pacc = pci_alloc();

	pci_init(pacc);
	pci_scan_bus(pacc);

	dev = pacc->devices;
	while(dev != NULL)
	{
		/* collect data */
		pci_fill_info(dev, PCI_FILL_IDENT);
		c = pci_read_word(dev, PCI_CLASS_DEVICE);

		/* send data */
		pvm_initsend(PvmDataDefault);
		pvm_pkuint((unsigned int *)&c, 1, 1);					/* class */
		pvm_pkuint((unsigned int *)&(dev->bus), 1, 1);			/* bus */
		pvm_pkuint((unsigned int *)&(dev->dev), 1, 1);			/* device */
		pvm_pkuint((unsigned int *)&(dev->func), 1, 1);			/* function */
		pvm_pkuint((unsigned int *)&(dev->vendor_id), 1, 1);	/* vendor id */
		pvm_pkuint((unsigned int *)&(dev->device_id), 1, 1);	/* device id */
		pvm_send(pvm_parent(), MSGTAG_PCIINFO);

		/* continue */
		dev = dev->next;
	}

	pci_cleanup(pacc);

	return EXIT_SUCCESS;
}

