#include <stdlib.h>
#include <assert.h>

#include "slist.h"

SList *slist_new(void *data)
{
	SList *new;

	new = calloc(1, sizeof(SList));
	if(new)
	{
		new->data = data;
	}

	return new;
}

unsigned int slist_length(SList *slist)
{
	unsigned int length = 0;
	SList *item;

	item = slist;

	while(item)
	{
		length ++;
		item = item->next;
	}

	return length;
}

SList *slist_nth(SList *slist, unsigned int n)
{
	unsigned int index;
	SList *item;

	index = 0;
	item = slist;

	while((index < n) && item)
	{
		index ++;
		item = item->next;
	}

	return item;
}

SList *slist_last(SList *slist)
{
	SList *last;

	last = slist;

	while(last && last->next) last = last->next;

	return last;
}

SList *slist_append(SList *slist, void *data)
{
	SList *last, *new;

	new = slist_new(data);
	assert(new != NULL);

	if(slist == NULL)
	{
		return new;
	}

	last = slist_last(slist);
	last->next = new;

	return slist;
}

